<template>
  <div>
    <!-- TODO: action path -->
    <el-upload
      action="#"
      :auto-upload="true"
      :on-remove="handleRemove"
      :file-list="fileList"
      multiple
      :limit="SQLite? 1 : 5"
      :on-exceed="handleExceed"
      :before-remove="beforeRemove"
      :http-request="doUpload"
      :on-error="handleError"
      :on-success="handleSuccess"
      ref="upload">
      <el-button slot="trigger" size="small" type="primary">{{ $t('UPLOAD.FILE_ADD') }} [+]</el-button>
      <el-select
        v-if="SQLite"
        v-model="selectedSqliteFile"
        :placeholder="$t('UPLOAD.PREV_SLCT')"
        @change="onChange('previousSql')">
        <el-option
          v-for="file in previousSqliteFile"
          :label="file.name"
          :key="file.file_guid"
          :value="file.file_guid">
        </el-option>
      </el-select>
    </el-upload>
    <i class="el-icon-loading" v-if="loading" />
  </div>
</template>

<script>
import { mapState, mapMutations, mapGetters, mapActions } from 'vuex';

export default {
  name: 'Upload',
  props: ['from'],
  data() {
    return {
      loading: false,
      SQLite: false,
      selectedSqliteFile: '',
    };
  },
  computed: {
    ...mapState('scItem', ['sc']),
    ...mapGetters('scItem', ['currentEditingScItem']),
    fileList: {
      get() {
        const vm = this;
        switch (vm.from) {
          case 'ScQuestionEditor':
          case 'ScSurveyEditor':
          case 'ScHomeworkEditor':
          case 'ScMaterialEditor': {
            const scItem = vm.currentEditingScItem;
            return scItem ? scItem.fileList : [];
          }
          case 'ScQuestionSQLite': {
            vm.SQLite = true;
            const scItem = vm.currentEditingScItem;
            vm.selectedSqliteFile = '';
            return scItem ? scItem.SQLiteFile : [];
          }
          default: {
            throw new Error(`not defined type ${vm.from}`);
          }
        }
      },
      set(fileList) {
        const vm = this;
        switch (vm.from) {
          case 'ScQuestionEditor':
          case 'ScSurveyEditor':
          case 'ScHomeworkEditor':
          case 'ScMaterialEditor': {
            // for fileList of ScMaterialEditor
            vm.assignCurrentEditingScItem({
              currentEditingScItem: {
                fileList,
              },
            });
            break;
          }
          case 'ScQuestionSQLite': {
            vm.assignCurrentEditingScItem({
              currentEditingScItem: {
                SQLiteFile: fileList,
              },
            });
            break;
          }
          default: {
            break;
          }
        }
      },
    },
    previousSqliteFile: {
      get() {
        const vm = this;
        return vm.currentEditingScItem.question.previousSqliteFiles;
      },
    },
  },
  methods: {
    ...mapMutations('scItem', ['assignCurrentEditingScItem']),
    ...mapActions('scItem', [
      'getScItem',
      'postFile',
      'selectPreviousSqlite',
      'deleteFile',
      'deleteFileSqlite',
    ]),
    handleExceed(files, fileList) {
      // TODO: translate
      if (this.SQLite) {
        this.$message.warning(
          vm.$t('WARNING.SQLITE_ONLY_ONE'),
        );
      } else {
        this.$message.warning(
          vm.$t('WARNING.FIVE_FILE1') +
        vm.$t('WARNING.FIVE_FILE2') + `${files.length}` + vm.$t('WARNING.FIVE_FILE3') +
        vm.$t('WARNING.FIVE_FILE4') + `${files.length + fileList.length}`,
        );
      }
    },
    beforeRemove(file) {
      // TODO: translate
      return this.$confirm(`${file.name} 파일을 삭제하시겠습니까？`);
    },
    async handleRemove(file) {
      const vm = this;
      try {
        vm.loading = true;
        if (!vm.SQLite) {
          vm.deleteFile({
            fileGuid: file.guid,
          });
        } else {
          vm.deleteFileSqlite({
            fileGuid: file.guid,
            questionId: vm.currentEditingScItem.question.id,
          });
          vm.fileList = [];
        }
      } catch (error) {
        vm.$notify({
          title: `${file.name} ` + vm.$t('NOTIFY.DELETE_FAIL'),
          message: error.toString(),
          type: 'error',
          duration: 0,
        });
      } finally {
        vm.loading = false;
      }
    },
    handleSuccess(res, file) { // eslint-disable-line
      const vm = this;
      vm.loading = false;
      // console.log(res, file, fileList);
    },
    handleError(err, file) {
      const vm = this;
      vm.loading = false;
      // console.log(err, file, fileList);
      vm.$notify({
        title: 'Upload failed',
        message: `${file.name} ${err}`,
        type: 'error',
      });
    },
    // handleChange(file, fileList) {
    //   const vm = this;
    //   // vm.fileList.push(file);
    //   // vm.fileList = fileList;
    //   console.log('handleChange', file, fileList);
    // },
    async doUpload(req) {
      // console.log('req', req);
      const vm = this;
      vm.loading = true;
      switch (vm.from) {
        case 'ScQuestionEditor':
        case 'ScSurveyEditor':
        case 'ScHomeworkEditor':
        case 'ScMaterialEditor': {
          await vm.postFile({
            file: req.file,
          });
          break;
        }
        case 'ScQuestionSQLite': {
          await vm.postFile({
            file: req.file,
            SQLite: true,
          });
          break;
        }
        default: {
          throw new Error(`not defined from ${vm.from}`);
        }
      }
    },
    async onChange(type) {
      const vm = this;
      switch (type) {
        case 'previousSql': {
          if (vm.fileList.length > 0) {
            this.$message.warning(
              vm.$t('WARNING.SQLITE_ONLY_ONE'),
            );
            vm.selectedSqliteFile = '';
          } else {
            await vm.selectPreviousSqlite({
              guid: vm.selectedSqliteFile,
              questionId: vm.currentEditingScItem.question.id,
            });
            vm.getScItem({
              scItemId: vm.currentEditingScItem.id,
            });
          }
          break;
        }
        default: {
          throw new Error('not defined onChange type');
        }
      }
    },
  },
};
</script>
